4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
19 while case "$#" in 0) break ;; esac
22 -a|--a|--ap|--app|--appe|--appen|--append)
25 -f|--f|--fo|--for|--forc|--force)
28 -t|--t|--ta|--tag|--tags)
31 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
32 --update-he|--update-hea|--update-head|--update-head-|\
33 --update-head-o|--update-head-ok)
51 test -f "$GIT_DIR/branches/origin" ||
52 test -f "$GIT_DIR/remotes/origin" ||
53 die "Where do you want to fetch from today?"
58 remote=$(get_remote_url "$@")
61 rsync_slurped_objects=
63 if test "" = "$append"
65 : >"$GIT_DIR/FETCH_HEAD"
68 append_fetch_head () {
75 t) not_for_merge_='not-for-merge' ;;
76 '') not_for_merge_= ;;
79 # remote-nick is the URL given on the command line (or a shorthand)
80 # remote-name is the $GIT_DIR relative refs/ path we computed
82 case "$remote_name_" in
86 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
87 note_="branch '$note_' of " ;;
89 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
90 note_="tag '$note_' of " ;;
92 note_="$remote_name of " ;;
94 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
96 note_="$note_$remote_"
98 # 2.6.11-tree tag would not be happy to be fed to resolve.
99 if git-cat-file commit "$head_" >/dev/null 2>&1
101 headc_=$(git-rev-parse --verify "$head_^0") || exit
102 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
103 [ "$verbose" ] && echo >&2 "* committish: $head_"
104 [ "$verbose" ] && echo >&2 " $note_"
106 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
107 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
108 [ "$verbose" ] && echo >&2 " $note_"
110 if test "$local_name_" != ""
112 # We are storing the head locally. Make sure that it is
113 # a fast forward (aka "reverse push").
114 fast_forward_local "$local_name_" "$head_" "$note_"
118 fast_forward_local () {
119 mkdir -p "$(dirname "$GIT_DIR/$1")"
122 # Tags need not be pointing at commits so there
123 # is no way to guarantee "fast-forward" anyway.
124 if test -f "$GIT_DIR/$1"
126 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
128 [ "$verbose" ] && echo >&2 "* $1: same as $3"
130 echo >&2 "* $1: updating with $3"
133 echo >&2 "* $1: storing $3"
135 git-update-ref "$1" "$2"
139 # $1 is the ref being updated.
140 # $2 is the new value for the ref.
141 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
144 # Require fast-forward.
145 mb=$(git-merge-base "$local" "$2") &&
148 echo >&2 "* $1: same as $3"
151 echo >&2 "* $1: fast forward to $3"
152 git-update-ref "$1" "$2" "$local"
158 echo >&2 "* $1: does not fast forward to $3;"
159 case ",$force,$single_force," in
161 echo >&2 " forcing update."
162 git-update-ref "$1" "$2" "$local"
165 echo >&2 " not updating."
170 echo >&2 "* $1: storing $3"
171 git-update-ref "$1" "$2"
177 case "$update_head_ok" in
179 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
183 # If --tags (and later --heads or --all) is specified, then we are
184 # not talking about defaults stored in Pull: line of remotes or
185 # branches file, and just fetch those and refspecs explicitly given.
186 # Otherwise we do what we always did.
188 reflist=$(get_remote_refs_for_fetch "$@")
191 taglist=$(git-ls-remote --tags "$remote" |
198 # remote URL plus explicit refspecs; we need to merge them.
199 reflist="$reflist$LF$taglist"
201 # No explicit refspecs; fetch tags only.
210 # These are relative path from $GIT_DIR, typically starting at refs/
212 if expr "$ref" : '\.' >/dev/null
215 ref=$(expr "$ref" : '\.\(.*\)')
219 if expr "$ref" : '\+' >/dev/null
222 ref=$(expr "$ref" : '\+\(.*\)')
226 remote_name=$(expr "$ref" : '\([^:]*\):')
227 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
229 rref="$rref$LF$remote_name"
231 # There are transports that can fetch only one head at a time...
233 http://* | https://*)
234 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
237 remote_name_quoted=$(perl -e '
239 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
242 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
243 expr "$head" : "$_x40\$" >/dev/null ||
244 die "Failed to fetch $remote_name from $remote"
245 echo >&2 Fetching "$remote_name from $remote" using http
246 git-http-fetch -v -a "$head" "$remote/" || exit
249 TMP_HEAD="$GIT_DIR/TMP_HEAD"
250 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
251 head=$(git-rev-parse --verify TMP_HEAD)
253 test "$rsync_slurped_objects" || {
254 rsync -av --ignore-existing --exclude info \
255 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
257 # Look at objects/info/alternates for rsync -- http will
258 # support it natively and git native ones will do it on the remote
259 # end. Not having that file is not a crime.
260 rsync -q "$remote/objects/info/alternates" \
261 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
262 rm -f "$GIT_DIR/TMP_ALT"
263 if test -f "$GIT_DIR/TMP_ALT"
265 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
268 case "$alt" in 'bad alternate: '*) die "$alt";; esac
269 echo >&2 "Getting alternate: $alt"
270 rsync -av --ignore-existing --exclude info \
271 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
273 rm -f "$GIT_DIR/TMP_ALT"
275 rsync_slurped_objects=t
279 # We will do git native transport with just one call later.
283 append_fetch_head "$head" "$remote" \
284 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
289 http://* | https://* | rsync://* )
290 ;; # we are already done.
294 git-fetch-pack "$remote" $rref || echo failed "$remote"
296 while read sha1 remote_name
300 echo >&2 "Fetch failure: $remote"
328 local_name=$(expr "$found" : '[^:]*:\(.*\)')
329 append_fetch_head "$sha1" "$remote" \
330 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
335 # If the original head was empty (i.e. no "master" yet), or
336 # if we were told not to worry, we do not have to check.
337 case ",$update_head_ok,$orig_head," in
341 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
342 if test "$curr_head" != "$orig_head"
344 git-update-ref HEAD "$orig_head"
345 die "Cannot fetch into the current branch."